<?php

class RegioesController extends Controller
{
    private $regiaoModel;

    public function __construct()
    {
        if (!Sessao::estaLogado()) {
            URL::redirecionar('usuarios/login');
        }
        $this->regiaoModel = $this->model('Regiao');
    }

    public function index()
    {
        $dados = [
            'regioes' => $this->regiaoModel->lerRegioes()
        ];
        $this->view('layout', [
            'conteudo' => __DIR__ . '/../Views/regioes/index.php',
            'dados'    => $dados
        ]);
    }

    public function cadastrar()
    {
        if ($_SERVER['REQUEST_METHOD'] == 'POST') {
            $formulario = filter_input_array(INPUT_POST, FILTER_SANITIZE_SPECIAL_CHARS);

            $dados = [
                'nome'       => strtoupper($formulario['nome'] ?? ''),
                'id_usuario' => $_SESSION['id_usuario'] ?? 1
            ];

            if ($this->regiaoModel->armazenar($dados)) {
                Sessao::mensagem('regiao', 'Região cadastrada com sucesso!');
                URL::redirecionar('regioes');
            } else {
                Sessao::mensagem('regiao', 'Erro ao cadastrar região', 'alert alert-danger');
            }
        }

        $this->view('layout', [
            'conteudo' => __DIR__ . '/../Views/regioes/cadastrar.php',
            'dados'    => []
        ]);
    }

    public function editar($id)
    {
        if ($_SERVER['REQUEST_METHOD'] == 'POST') {
            $formulario = filter_input_array(INPUT_POST, FILTER_SANITIZE_SPECIAL_CHARS);

            $dados = [
                'id_regioes' => $id,
                'nome'       => strtoupper($formulario['nome'] ?? '')
            ];

            if ($this->regiaoModel->atualizar($dados)) {
                Sessao::mensagem('regiao', 'Região atualizada com sucesso!');
                URL::redirecionar('regioes');
            } else {
                Sessao::mensagem('regiao', 'Erro ao atualizar região', 'alert alert-danger');
            }
        }

        $regiao = $this->regiaoModel->lerRegiaoPorId($id);

        $dados = [
            'regiao' => $regiao
        ];

        $this->view('layout', [
            'conteudo' => __DIR__ . '/../Views/regioes/editar.php',
            'dados'    => $dados
        ]);
    }

    public function visualizar($id)
    {
        $dados = [
            'regiao' => $this->regiaoModel->lerRegiaoPorId($id)
        ];
        $this->view('layout', [
            'conteudo' => __DIR__ . '/../Views/regioes/visualizar.php',
            'dados'    => $dados
        ]);
    }

    public function excluir($id)
    {
        if ($this->regiaoModel->remover($id)) {
            Sessao::mensagem('regiao', 'Região removida com sucesso!');
        } else {
            Sessao::mensagem('regiao', 'Erro ao remover região', 'alert alert-danger');
        }
        URL::redirecionar('regioes');
    }
}
